#include <amxmodx>
#include <hamsandwich>
#include <fakemeta>
#include <reapi>
#include <weapons>

#define ID_M1911A1 7634198
#define STRN_M1911A1 "weapon_m1911a1"
#define CLIP_M1911A1 8
#define MAXAMMO_M1911A1 100

enum
{
	ANIM_IDLE,
	ANIM_IDLE_EMPTY,
	ANIM_SHOOT1,
	ANIM_SHOOT2,
	ANIM_SHOOT_EMPTY,
	ANIM_RELOAD,
	ANIM_RELOAD_EMPTY,
	ANIM_DRAW,
	ANIM_DRAW_EMPTY
}

#define VIEWMODEL "models/406/v_m1911a1.mdl"
#define WEAPONMODEL "models/406/p_m1911a1.mdl"
#define WORLDMODEL "models/406/w_m1911a1.mdl"
#define SHOOTSOUND "weapons/406/coltm1911a1-1.wav"

new pPlayer, pEntity, HookChain:TakeDamage

public plugin_precache()
{
	engfunc(EngFunc_PrecacheSound, SHOOTSOUND)
	engfunc(EngFunc_PrecacheGeneric, "sound/weapons/406/coltm1911a1_clipin.wav")
	engfunc(EngFunc_PrecacheGeneric, "sound/weapons/406/coltm1911a1_clipout.wav")
	engfunc(EngFunc_PrecacheGeneric, "sound/weapons/406/coltm1911a1_slideback.wav")
	engfunc(EngFunc_PrecacheModel, VIEWMODEL)
	engfunc(EngFunc_PrecacheModel, WEAPONMODEL)
	engfunc(EngFunc_PrecacheModel, WORLDMODEL)
	engfunc(EngFunc_PrecacheGeneric, "sprites/406/640hud7.spr")
	engfunc(EngFunc_PrecacheGeneric, "sprites/406/640hud114.spr")
	engfunc(EngFunc_PrecacheGeneric, "sprites/weapon_m1911a1.txt")
}

public plugin_init()
{
	register_plugin("Weapon: M1911 A1", "16.11.2018", "406")
	RegisterHam(Ham_Item_Deploy, STRN_FIVESEVEN, "fw_ItemDeployPre")
	RegisterHam(Ham_Weapon_PrimaryAttack, STRN_FIVESEVEN, "fw_WeaponPrimaryAttackPre")
	RegisterHam(Ham_Weapon_Reload, STRN_FIVESEVEN, "fw_WeaponReloadPre")
	RegisterHam(Ham_Item_AddToPlayer, STRN_FIVESEVEN, "fw_ItemAddToPlayerPost", 1)
	RegisterHam(Ham_Weapon_WeaponIdle, STRN_FIVESEVEN, "fw_WeaponWeaponIdlePost", 1)
	register_forward(FM_UpdateClientData, "fm_UpdateClientDataPost", 1)
	RegisterHookChain(RG_CWeaponBox_SetModel, "rg_CWeaponBoxSetModelPre")
	TakeDamage = RegisterHookChain(RG_CBasePlayer_TakeDamage, "rg_CBasePlayerTakeDamagePre")
	DisableHookChain(TakeDamage)
	register_clcmd("give_m1911a1", "give_m1911a1")
	register_clcmd(STRN_M1911A1, "lastinv_m1911a1")
}

public give_m1911a1(player)
{
	if(!is_user_alive(player)) return
	pEntity = rg_give_custom_item(player, STRN_FIVESEVEN, GT_DROP_AND_REPLACE, ID_M1911A1)
	set_member(pEntity, m_Weapon_iClip, CLIP_M1911A1)
	rg_set_iteminfo(pEntity, ItemInfo_iMaxClip, CLIP_M1911A1)
	if(get_member(player, m_rgAmmo, AMMOID_FIVESEVEN) < MAXAMMO_M1911A1)
	set_member(player, m_rgAmmo, MAXAMMO_M1911A1, AMMOID_FIVESEVEN)
}

public rg_CWeaponBoxSetModelPre(entity, const szModelName[])
{
	pEntity = get_member(entity, m_WeaponBox_rgpPlayerItems, PISTOL_SLOT)
	if(is_entity(pEntity) && get_entvar(pEntity, var_impulse) == ID_M1911A1)
	SetHookChainArg(2, ATYPE_STRING, WORLDMODEL)
}

public fw_WeaponWeaponIdlePost(entity)
{
	if(get_entvar(entity, var_impulse) != ID_M1911A1 || get_member(entity, m_Weapon_flTimeWeaponIdle) > 0.0) return
	set_entvar(get_member(entity, m_pPlayer), var_weaponanim, ANIM_IDLE_EMPTY)
	set_member(entity, m_Weapon_flTimeWeaponIdle, 99999.0)
}

public fw_ItemAddToPlayerPost(entity, player)
{
	new iCustom = get_entvar(entity, var_impulse)
	if(iCustom && (iCustom != ID_M1911A1)) return
	SendWeaponList(player, (iCustom != ID_M1911A1) ? STRN_FIVESEVEN : STRN_M1911A1, AMMOID_FIVESEVEN, MAXAMMO_FIVESEVEN, SLOT_SECONDARY, POSITION_FIVESEVEN, ID_FIVESEVEN)
}

public fw_ItemDeployPre(entity)
{
	pPlayer = get_member(entity, m_pPlayer)
	if(get_member(pPlayer, m_pLastItem) == entity)
	{
		set_entvar(pPlayer, var_viewmodel, VIEWMODEL)
		set_entvar(pPlayer, var_weaponmodel, WEAPONMODEL)
		return HAM_SUPERCEDE
	}
	if(get_entvar(entity, var_impulse) != ID_M1911A1) return HAM_IGNORED
	ExecuteHam(Ham_Item_Deploy, entity)
	set_entvar(pPlayer, var_viewmodel, VIEWMODEL)
	set_entvar(pPlayer, var_weaponmodel, WEAPONMODEL)
	SendWeaponAnim(pPlayer, get_member(entity, m_Weapon_iClip) ? ANIM_DRAW : ANIM_DRAW_EMPTY)
	set_member(pPlayer, m_flNextAttack, 0.9)
	set_member(entity, m_Weapon_flTimeWeaponIdle, 0.9)
	return HAM_SUPERCEDE
}

public fw_WeaponReloadPre(entity)
{
	if(get_entvar(entity, var_impulse) != ID_M1911A1) return HAM_IGNORED
	new iClip = get_member(entity, m_Weapon_iClip)
	pPlayer = get_member(entity, m_pPlayer)
	if(iClip >= CLIP_M1911A1 || !get_member(pPlayer, m_rgAmmo, AMMOID_FIVESEVEN)) return HAM_SUPERCEDE
	ExecuteHam(Ham_Weapon_Reload, entity)
	set_member(pPlayer, m_flNextAttack, 2.23)
	set_member(entity, m_Weapon_flTimeWeaponIdle, 2.23)
	set_entvar(pPlayer, var_weaponanim, iClip ? ANIM_RELOAD : ANIM_RELOAD_EMPTY)
	return HAM_SUPERCEDE
}

public fw_WeaponPrimaryAttackPre(entity)
{
	if(get_entvar(entity, var_impulse) != ID_M1911A1) return HAM_IGNORED
	if(get_member(entity, m_Weapon_iShotsFired)) return HAM_SUPERCEDE
	static iClip, iTraceLine, iPlaybackEvent
	iClip = get_member(entity, m_Weapon_iClip)
	if(iClip)
	{
		iTraceLine = register_forward(FM_TraceLine, "fm_TraceLinePost", 1)
		iPlaybackEvent = register_forward(FM_PlaybackEvent, "fm_PlaybackEventPre")
		EnableHookChain(TakeDamage)
	}
	ExecuteHam(Ham_Weapon_PrimaryAttack, entity)
	if(!iClip) return HAM_SUPERCEDE
	unregister_forward(FM_TraceLine, iTraceLine, 1)
	unregister_forward(FM_PlaybackEvent, iPlaybackEvent)
	DisableHookChain(TakeDamage)
	
	set_member(entity, m_Weapon_flTimeWeaponIdle, 1.033)
	set_member(entity, m_Weapon_flNextSecondaryAttack, 99999.0)
	pPlayer = get_member(entity, m_pPlayer)
	rh_emit_sound2(pPlayer, 0, CHAN_WEAPON, SHOOTSOUND)
	set_entvar(pPlayer, var_weaponanim, iClip == 1 ? ANIM_SHOOT_EMPTY : iClip & 1 ? ANIM_SHOOT1 : ANIM_SHOOT2)
	return HAM_SUPERCEDE
}

public fm_TraceLinePost(Float:vecStart[3], Float:vecEnd[3], noMonsters, pentToSkip, iTrace)
{
	if(noMonsters) return
	if(!GunshotDecalTrace(iTrace, true)) return
	get_tr2(iTrace, TR_vecEndPos, vecEnd)
	get_tr2(iTrace, TR_vecPlaneNormal, vecStart)
	CreateSmoke(SMOKE_WALLPUFF, vecEnd, vecStart, 0.5, Float:{40.0, 40.0, 40.0})
}

public fm_PlaybackEventPre() return FMRES_SUPERCEDE
public lastinv_m1911a1(player) engclient_cmd(player, STRN_FIVESEVEN)
public rg_CBasePlayerTakeDamagePre(victim, inflictor, attacker, Float:flDamage) SetHookChainArg(4, ATYPE_FLOAT, flDamage * 2.0)

public fm_UpdateClientDataPost(player, sendWeapons, cd)
{
	if(!is_user_alive(player)) return
	pEntity = get_member(player, m_pActiveItem)
	if(is_entity(pEntity) && get_entvar(pEntity, var_impulse) == ID_M1911A1)
	set_cd(cd, CD_flNextAttack, 99999.0)
}